(** File generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_alpha.Environment.
Require TezosOfOCaml.Proto_alpha.Constants_storage.
Require TezosOfOCaml.Proto_alpha.Origination_nonce.
Require TezosOfOCaml.Proto_alpha.Raw_context.
Require TezosOfOCaml.Proto_alpha.Storage.
Require TezosOfOCaml.Proto_alpha.Storage_sigs.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_inbox_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_inbox_storage.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_level_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_state_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_state_storage.

Definition fresh_tx_rollup_from_current_nonce (ctxt : Raw_context.t)
  : M? (Raw_context.t * Tx_rollup_repr.t) :=
  let? '(ctxt, nonce_value) := Raw_context.increment_origination_nonce ctxt in
  return? (ctxt, (Tx_rollup_repr.originated_tx_rollup nonce_value)).

Definition originate (ctxt : Raw_context.t)
  : M? (Raw_context.t * Tx_rollup_repr.t) :=
  let? '(ctxt, tx_rollup) := fresh_tx_rollup_from_current_nonce ctxt in
  let? ctxt := Tx_rollup_state_storage.init_value ctxt tx_rollup in
  return? (ctxt, tx_rollup).

Definition update_tx_rollups_at_block_finalization (ctxt : Raw_context.t)
  : M? Raw_context.t :=
  let '(ctxt, rollups) := Raw_context.get_tx_rollup_with_messages ctxt in
  Tx_rollup_repr._Set.(_Set.S.fold_es)
    (fun (tx_rollup : Tx_rollup_repr.Hash.t) =>
      fun (ctxt : Raw_context.t) =>
        let? '(ctxt, state_value) := Tx_rollup_state_storage.get ctxt tx_rollup
          in
        match Tx_rollup_state_repr.head_level state_value with
        | Some (tx_level, _) =>
          let? '(ctxt, inbox) :=
            Tx_rollup_inbox_storage.get ctxt tx_level tx_rollup in
          let hard_limit :=
            Constants_storage.tx_rollup_hard_size_limit_per_inbox ctxt in
          let state_value :=
            Tx_rollup_state_repr.update_burn_per_byte state_value
              inbox.(Tx_rollup_inbox_repr.t.cumulated_size) hard_limit in
          let? '(ctxt, _, _) :=
            Storage.Tx_rollup.State.(Storage_sigs.Non_iterable_indexed_carbonated_data_storage.add)
              ctxt tx_rollup state_value in
          return? ctxt
        | None => return? ctxt
        end) rollups ctxt.
